#ifndef POOL_H
#define POOL_H

#ifndef POOL_CONTENT_T
#define POOL_CONTENT_T char
#endif /* POOL_CONTENT_T */

struct maillot {
  POOL_CONTENT_T content;
  int proc,prec;
  int libre;
};

#define MAX_ENTRIES 1024

struct pool {
  int no_libres;
  int no_occupes;
  int premier_libre;
  int premier_occupe;
  struct maillot maillot[MAX_ENTRIES];
};

#define NO_LIBRES(pool) \
((pool)->no_libres)
#define NO_OCCUPES(pool) \
((pool)->no_occupes)

#define CONTENU(pool,i) ((pool)->maillot[i].content)
#define EST_LIBRE(pool,i) ((pool)->maillot[i].libre)
#define PREC(pool,i) ((pool)->maillot[i].prec)
#define PROC(pool,i) ((pool)->maillot[i].proc)

#define PREMIER_LIBRE(pool) \
((pool)->premier_libre)
#define DERNIER_LIBRE(pool) \
(PREC(pool,PREMIER_LIBRE(pool))
#define PREMIER_OCCUPE(pool) \
((pool)->premier_occupe)
#define DERNIER_OCCUPE(pool) \
(PREC(pool,PREMIER_OCCUPE(pool))



extern 
void pool_init(struct pool *pool);
extern 
POOL_CONTENT_T *allouer(struct pool *pool);
extern 
int liberer(struct pool *pool,POOL_CONTENT_T * address);

#endif /* POOL_H */
